
#ifndef IC_BARCODE_ENUMS_H_INC_
#define IC_BARCODE_ENUMS_H_INC_

typedef enum ICBarcode_Format
{
	IC_BARCODEFORMAT_NONE = 0,
	IC_BARCODEFORMAT_AZTEC = 1 << 1,
	IC_BARCODEFORMAT_CODE_39 = 1 << 3,
	IC_BARCODEFORMAT_CODE_93 = 1 << 4,
	IC_BARCODEFORMAT_CODE_128 = 1 << 5,
	IC_BARCODEFORMAT_DATA_MATRIX = 1 << 6,
	IC_BARCODEFORMAT_EAN_8 = 1 << 7,
	IC_BARCODEFORMAT_EAN_13 = 1 << 8,
	IC_BARCODEFORMAT_MAXICODE = 1 << 10,
	IC_BARCODEFORMAT_PDF_417 = 1 << 11,
	IC_BARCODEFORMAT_QR_CODE = 1 << 12,
	IC_BARCODEFORMAT_UPC_A = 1 << 15,
	IC_BARCODEFORMAT_UPC_E = 1 << 16,
	IC_BARCODEFORMAT_UPC_EAN_EXTENSION = 1 << 17,
	IC_BARCODEFORMAT_INTERLEAVED_2_OF_5 = 1 << 18,

    IC_BARCODEFORMAT_1D = IC_BARCODEFORMAT_CODE_39 | IC_BARCODEFORMAT_CODE_93 | IC_BARCODEFORMAT_CODE_128 |
                                IC_BARCODEFORMAT_EAN_8 | IC_BARCODEFORMAT_EAN_13 | 
                                IC_BARCODEFORMAT_UPC_A | IC_BARCODEFORMAT_UPC_E | IC_BARCODEFORMAT_UPC_EAN_EXTENSION |
                                IC_BARCODEFORMAT_INTERLEAVED_2_OF_5,

    IC_BARCODEFORMAT_2D = IC_BARCODEFORMAT_AZTEC | IC_BARCODEFORMAT_DATA_MATRIX | IC_BARCODEFORMAT_MAXICODE | IC_BARCODEFORMAT_PDF_417 | IC_BARCODEFORMAT_QR_CODE,

    IC_BARCODEFORMAT_ALL = IC_BARCODEFORMAT_1D | IC_BARCODEFORMAT_2D,

} ICBarcode_Format;

typedef enum ICBarcode_Param
{
	IC_BARCODEPARAMS_CHECK_CHAR,
	IC_BARCODEPARAMS_NUM_SCANLINES, // unused
	IC_BARCODEPARAMS_ELEMENT_SIZE_MIN,
	IC_BARCODEPARAMS_ELEMENT_SIZE_MAX,
	IC_BARCODEPARAMS_ORIENTATION,
	IC_BARCODEPARAMS_ORIENTATION_TOL,
	IC_BARCODEPARAMS_STOP_AFTER_NUM_RESULTS,
	IC_BARCODEPARAMS_TIMEOUT,
	IC_BARCODEPARAMS_MIN_WIDTH,
	IC_BARCODEPARAMS_MIN_HEIGHT,
	IC_BARCODEPARAMS_MAX_WIDTH,
	IC_BARCODEPARAMS_MAX_HEIGHT,
	IC_BARCODEPARAMS_PREPROCESS,
	IC_BARCODEPARAMS_TRY_HARDER,
	IC_BARCODEPARAMS_IC_ONLY,
	IC_BARCODEPARAMS_FIXED_DATA_LENGTH,

    IC_BARCODEPARAMS_STORE_DEBUG_INFO,
    IC_BARCODEPARAMS_USE_MULTITHREADING,
} ICBarcode_Param;

#endif